var app = app || {};

app.db = {
	db:null,

	initialize:function(){
		this.db = queryModule('sqlite');

		this.db.create("db",this.db.CREATE | this.db.READWRITE);
		this.db.prepare("create table IF NOT EXISTS version('id' INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,			\
															'version' INTERGER NOT NULL									\
		)").exec();

		this.db.prepare("create table IF NOT EXISTS films('id' INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,				\
														'name' TEXT UNIQUE,												\
														'filePath' TEXT COLLATE NOCASE,									\
														'type' TEXT,													\
														'date' TEXT,													\
														'time' INTEGER,													\
														'score' INTERGER,												\
														'doubanID' INTERGER,											\
														'cover' TEXT,													\
														'leader' TEXT,													\
														'summary' TEXT,													\
														'state' INTERGER default(0)										\
		)").exec();

		//state 0等待获取信息 1信息已获取成功 2信息获取失败 3移除

		this.db.prepare("create table IF NOT EXISTS setting('id' INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,			\
															'name' TEXT,												\
															'mail' TEXT,												\
															'path' TEXT,												\
															'autoDel' INTERGER											\
		)").exec();

		this.db.prepare("replace into version values(?,?)").exec(1,1);

		var result = this.db.prepare("select * from setting").exec();
		if (result.length == 0)
			this.db.prepare("replace into setting(id) values(1)").exec();
	},

	saveSet:function(items){
		_.each(items,function(item,i){
			app.db.custom().prepare("update setting set " + i + "=? where id=1").exec(item);
		});
	},

	querySet:function(item){
		var result = this.db.prepare("select * from setting where id=1").exec();
		if (result.length > 0)
			return result[0][item];
	},

	addFile:function(filePath){
		this.db.prepare("INSERT INTO films(filePath) SELECT ? WHERE NOT EXISTS (SELECT 1 FROM films WHERE filePath=?)").exec(filePath,filePath);
	},

	updateInfo:function(name,filePath,type,date,time,score,doubanID,cover,leader,summary){
		this.db.prepare("update films set name=?,type=?,date=?,time=?,score=?,doubanID=?,cover=?,leader=?,summary=?,state=1 where filePath=?").exec(name,type,date,time,score,doubanID,cover,leader,summary,filePath);
	},

	queryAll:function(state){
		if (_.isUndefined(state))
			return this.db.prepare("select * from films").exec();

		return this.db.prepare("select * from films where state=?").exec(state);
	},

	custom:function(){
		return this.db;
	}
	//select * from films a where id=(select min(id) from films where name=a.name)
};