var app = app || {};

app.feedback = Backbone.View.extend({
	el:"#popModal .modal-body",

	events:{
		"click .feedback_reply":"onReply",
		"click .feedback_del":"onDel",
		"click .feedback_page":"onPage",
		"mouseenter .media-body":"onMouse",
		"mouseleave .media-body":"onMouse",

		"submit form":"onSubmit"
	},

	mainTemplate:_.template($("#feedback-template").html()),
	itemTemplate:_.template($("#feedbackItem-template").html()),
	pageTemplate:_.template($("#feedbackPage-template").html()),

	url:"http://hummerstudio.com/feedback2",
	isAdmin:false,

	initialize:function(){
		ga.page('/feedback');

		this.$el.html(this.mainTemplate());

		$('.feedback').slimScroll({height: (win.height - 140) + "px"});
		$("#popModal").modal('show');

		this.query(0);
	},

	query:function(page){
		$("#feedback_form button").prop('disabled',true);
		$("#feedbackLoader").removeClass('hidden');

		$.post(this.url,"pdt=fb_MoviePicker&method=query&page=" + page,_.bind(function(result){
            var tempString = "";
            var itemTemplate = this.itemTemplate;

            _.each(result['content'],function(item){

            	tempString += itemTemplate(item);

            	if (item['reply'].length > 0)
            		tempString += "<div style='margin:10px 0 40px 60px;'>";
                
            	_.each(item['reply'],function(item2){
            		tempString += itemTemplate(item2);
            	})

            	if (item['reply'].length > 0)
            		tempString += "</div>";
            })

            $("#feedback_page").html(this.pageTemplate({currentPage:result['currentPage'],totalPage:result['totalPage']}));
            $("#feedback_content").html(tempString);

            $('#feedbackDialog .modal-body').slimScroll({scrollTo:0});

            $("#feedback_form button").prop('disabled',false);

            this.isAdmin = result['isAdmin'];

        },this),'json').always(function(){
        	$("#feedbackLoader").addClass('hidden');
        })
	},

	onReply:function(e){
		$('#feedbackDialog .modal-body').slimScroll({scrollTo: $('#feedbackDialog .modal-body').prop('scrollHeight') + 'px'});
		$("#feedback_form textarea").focus();

		$("#feedback_form input[name=reply_id]").val($(e.currentTarget).parents(".media").attr('msgID'));
	},

	onDel:function(e){
		$.post(this.url,"pdt=fb_MoviePicker&method=del&id=" + $(e.currentTarget).parents(".media").attr('msgID'),_.bind(function(result){
            	this.query(0);
        	},this)
        );
	},

	onPage:function(e){
		this.query($(e.currentTarget).attr('page'));
	},

	onMouse:function(e){
		if (e.type == "mouseenter")
		{
			$(e.currentTarget).find(".feedback_reply").removeClass('hidden');
			if (this.isAdmin)
				$(e.currentTarget).find(".feedback_del").removeClass('hidden');
		}
		else
		{
			$(e.currentTarget).find(".feedback_reply").addClass('hidden');
			$(e.currentTarget).find(".feedback_del").addClass('hidden');
		}
	},

	onSubmit:function(e){
		var name = $("#feedback_name");
		var mail = $("#feedback_mail");
		var msg = $("#feedback_msg");

		if ($.trim(name.val()) == "")
        {
            name.focus();
            return false;
        }

        if ($.trim(msg.val()) == "")
        {
            msg.focus();
            return false;
        }

        $(e.currentTarget).find("button").button('loading');

        $.post(this.url,$(e.currentTarget).serialize(),_.bind(function(){
            $("#feedback_form textarea").val("");

            app.db.saveSet({name:$("#feedback_name").val(),mail:$("#feedback_mail").val()});
            this.query(0);
        },this)).always(function(){
        	$("#feedback_form button").button('reset');
        })

		return false;
	}
});