var app = app || {};

app.films = {
	getLocal:function(callback){

		result = app.db.custom().prepare('select * from films where state<>0 and state<>3').exec();

		if (result.length > 0)
		{
			var items =[];
			var autoDel = app.db.querySet('autoDel');
			_.each(result,function(item){
				if (autoDel)
				{
					var filePaths = item['filePath'].split("|");

					if (filePaths.length > 0)
					{
						if (queryModule('file').isFileExist(filePaths[0]))
						{
							items.push(app.units.parseFilmsInfo(item));
							return;
						}
					}

					app.db.custom().prepare('delete from films where id=?').exec(item['id']);
				}
				else
				{
					items.push(app.units.parseFilmsInfo(item));
				}
			})
			
			app.units.addMultilFilms(items);
		}

		if (!app.db.querySet('path'))
			return;

		app.ref.inc();
		queryModule('file').enumFiles({path:app.db.querySet('path'),filter:"\.mkv$",callback:function(name,attr,size){
				if (size < 1024 * 1024 * 200)
					return;

				var showName = app.units.getFilmsName(name);
				if (!showName)
					return;

				if (app.db.custom().prepare("select * from films where filePath like ?").exec("%" + name + "%").length > 0)
					return;

				app.db.custom().prepare("insert or replace into films(name,filePath) values(?,									\
											trim(ifnull((select filePath from films where name=?),'') || '|' || ?,'|')			\
										)").exec(showName,showName,name);

			},completed:_.bind(function(){
				var result = app.db.custom().prepare('select * from films films where state=0').exec();

				for (var i in result)
				{
					if (result[i]['doubanID'])
					{
						app.films.getFilmInfo(result[i]['name'],result[i]['doubanID'],this,result[i]['filePath']);
					}
					else
					{
						//http://movie.douban.com/j/subject_suggest?q=
						app.ref.inc();
						$.ajax({url:"http://movie.douban.com/subject_search?search_text=" + result[i]['name'].replace(/\./g,'+'),success:_.bind(function(result){

								var result = $(result).find(".item");
								if (result.length == 0)
								{
									app.films.setFilmsFailed(this['name'],this['context']);
									return;
								}

								var subject = result.find(".nbg:first").attr('href').match(/http:\/\/movie\.douban\.com\/subject\/([\d]+)\//);
								if (subject)
									app.films.getFilmInfo(this['name'],subject[1],this['callback'],this['context']);
						    },{callback:this,name:result[i]['name'],context:result[i]['filePath']})
						}).fail(function(){
							app.units.failedTips();
						}).always(function(){
							app.ref.dec();
						})
					}
				}

				app.ref.dec();
			},callback)
		});
	},

	getPlaying:function(callback){

		app.ref.inc();
		$.ajax({url:'http://movie.douban.com/nowplaying',success:function(result){

				$(result).find("#nowplaying .list-item").each(function(index,item){
					app.films.getFilmInfo(null,$(item).attr("data-subject"),callback);
				});
		    }
		}).fail(function(){
			app.units.failedTips();
		}).always(function(){
			app.ref.dec();
		})
	},

	getComing:function(callback){
		app.ref.inc();
		$.ajax({url:'http://movie.douban.com/later',success:function(result){

				$(result).find(".item.mod").each(function(index,item){

					var subject = $(item).find(".thumb").attr('href').match(/http:\/\/movie\.douban\.com\/subject\/([\d]+)\//);

					if (subject)
						app.films.getFilmInfo(null,subject[1],callback);
					
				});
		    }
		}).fail(function(){
			app.units.failedTips();
		}).always(function(){
			app.ref.dec();
		})
	},

	getFilmInfo:function(name,id,callback,context){
		app.ref.inc();
		$.ajax({url:'http://movie.douban.com/subject/' + id + "/",success:_.bind(function(result){

				var result = $(result);
				var info = result.find("#info").text();
				var item = {name:"",score:"",leader:"",type:"",date:"",time:"",summary:""};

				item['name'] =	result.find("span[property='v:itemreviewed']").text();
				item['score'] =	result.find(".rating_num").text();
				item['cover'] = result.find(".rec:first").find("a").attr("data-pic");
				item['summary'] = (info + result.find("span[property='v:summary']").text()).replace(/(^\s*)|(\s*$)/g,"").replace(/[\n]{1}/g,"<br>");

				var leader = info.match(/主演: ([^\n]+)/);
				if (leader)
					item['leader'] = leader[1].split('/').slice(0,4);

				var type = info.match(/类型: ([^\n]+)/);
				if (type)
					item['type'] = type[1].split('/');

				var date = info.match(/上映日期: ([\d]+-[\d]+)/);
				if (date)
					item['date'] = date[1];
				
				var time = info.match(/片长: ([\d]+)/);
				if (time)
					item['time'] = time[1];

				item['doubanID'] = this['id'];

				callback(item,this['context']);
			},{id:id,context:context})
		}).fail(_.bind(function(){
			app.films.setFilmsFailed(this['name'],this['filePath']);

			app.units.failedTips();
		},{name:name,filePath:context})).always(function(){
			app.ref.dec();
		})
	},

	setFilmsFailed:function(name,filePath){
		app.db.custom().prepare('update films set state=2 where filePath=?').exec(filePath);

		if (name)
			app.units.addMultilFilms(app.units.parseFilmsInfo({name:name,filePath:filePath,date:'',time:'',cover:'',type:'',doubanID:'',score:'',leader:'',summary:''}));
	}
};